Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.Designer.cs	(revision 2901)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.Designer.cs	(revision 2909)
@@ -39,7 +39,8 @@
       this.graphVisualization.FileName = "";
       this.graphVisualization.Location = new System.Drawing.Point(0, 0);
-      this.graphVisualization.Magnification = new System.Drawing.SizeF(71F, 71F);
+      this.graphVisualization.Magnification = new System.Drawing.SizeF(80F, 80F);
       this.graphVisualization.Name = "graphVisualization";
       this.graphVisualization.Origin = new System.Drawing.Point(0, 0);
+      this.graphVisualization.PageSize = new System.Drawing.Size(100000, 100000);
       this.graphVisualization.ShowConnectors = true;
       this.graphVisualization.ShowRulers = false;
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.cs	(revision 2901)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/GraphVisualizationInfoView.cs	(revision 2909)
@@ -35,4 +35,6 @@
 using HeuristicLab.MainForm.WindowsForms;
 using HeuristicLab.Collections;
+using System.Diagnostics;
+using System.Threading;
 
 namespace HeuristicLab.Operators.Views.GraphVisualization {
@@ -335,4 +337,15 @@
         this.graphVisualization.Controller.RunActivity(layoutName);
         this.graphVisualization.Invalidate();
+
+        //fix to avoid negative shape positions after layouting
+        Thread.Sleep(100);
+        int minX = this.graphVisualization.Controller.Model.Shapes.Min(s => s.Location.X);
+        int shiftX = minX < 0 ? Math.Abs(minX) + 50 : 0;
+        int minY = this.graphVisualization.Controller.Model.Shapes.Min(s => s.Location.Y);
+        int shiftY = minY < 0 ? Math.Abs(minY) + 50 : 0;
+        if (minX < 0 || minY < 0) {
+          foreach (IShape s in this.Controller.Model.Shapes)
+            s.MoveBy(new Point(shiftX, shiftY));
+        }
       }
     }
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.Designer.cs	(revision 2901)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphView.Designer.cs	(revision 2909)
@@ -40,4 +40,5 @@
       this.zoomInButton = new System.Windows.Forms.Button();
       this.zoomOutButton = new System.Windows.Forms.Button();
+      this.buttonToolTip = new System.Windows.Forms.ToolTip();
       this.shapeContextMenu.SuspendLayout();
       this.splitContainer.Panel1.SuspendLayout();
@@ -54,7 +55,7 @@
       this.graphVisualizationInfoView.Caption = null;
       this.graphVisualizationInfoView.Content = null;
-      this.graphVisualizationInfoView.Location = new System.Drawing.Point(0, 27);
+      this.graphVisualizationInfoView.Location = new System.Drawing.Point(3, 30);
       this.graphVisualizationInfoView.Name = "graphVisualizationInfoView";
-      this.graphVisualizationInfoView.Size = new System.Drawing.Size(665, 251);
+      this.graphVisualizationInfoView.Size = new System.Drawing.Size(662, 248);
       this.graphVisualizationInfoView.TabIndex = 0;
       // 
@@ -138,5 +139,5 @@
       // selectButton
       // 
-      this.selectButton.Image = HeuristicLab.Common.Resources.Resources.FlagGreenIcon;
+      this.selectButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Pointer;
       this.selectButton.Location = new System.Drawing.Point(3, 3);
       this.selectButton.Name = "selectButton";
@@ -145,8 +146,9 @@
       this.selectButton.UseVisualStyleBackColor = true;
       this.selectButton.Click += new System.EventHandler(selectButton_Click);
+      this.buttonToolTip.SetToolTip(this.selectButton, "Select Tool");
       // 
       // panButton
       // 
-      this.panButton.Image = HeuristicLab.Common.Resources.Resources.FlagRedIcon;
+      this.panButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.Breakpoint;
       this.panButton.Location = new System.Drawing.Point(33, 3);
       this.panButton.Name = "panButton";
@@ -155,4 +157,5 @@
       this.panButton.UseVisualStyleBackColor = true;
       this.panButton.Click += new System.EventHandler(panButton_Click);
+      this.buttonToolTip.SetToolTip(this.panButton, "Pan Tool");
       // 
       // connectButton
@@ -165,4 +168,5 @@
       this.connectButton.UseVisualStyleBackColor = true;
       this.connectButton.Click += new System.EventHandler(connectButton_Click);
+      this.buttonToolTip.SetToolTip(this.connectButton, "Connection Tool");
       // 
       // relayoutButton
@@ -175,4 +179,5 @@
       this.relayoutButton.UseVisualStyleBackColor = true;
       this.relayoutButton.Click += new System.EventHandler(relayoutButton_Click);
+      this.buttonToolTip.SetToolTip(this.relayoutButton, "Relayout Graph");
       // 
       // zoomAreaButton
@@ -185,8 +190,9 @@
       this.zoomAreaButton.UseVisualStyleBackColor = true;
       this.zoomAreaButton.Click += new System.EventHandler(zoomAreaButton_Click);
+      this.buttonToolTip.SetToolTip(this.zoomAreaButton, "Zoom Area Tool");
       // 
       // zoomInButton
       // 
-      this.zoomInButton.Image = HeuristicLab.Common.Resources.Resources.ShowLargeIcons;
+      this.zoomInButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.ZoomIn;
       this.zoomInButton.Location = new System.Drawing.Point(183, 3);
       this.zoomInButton.Name = "zoomInButton";
@@ -195,8 +201,9 @@
       this.zoomInButton.UseVisualStyleBackColor = true;
       this.zoomInButton.Click += new System.EventHandler(zoomInButton_Click);
+      this.buttonToolTip.SetToolTip(this.zoomInButton, "Zoom In");
       // 
       // zoomOutButton
       // 
-      this.zoomOutButton.Image = HeuristicLab.Common.Resources.Resources.ShowSmallIcons;
+      this.zoomOutButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.ZoomOut;
       this.zoomOutButton.Location = new System.Drawing.Point(213, 3);
       this.zoomOutButton.Name = "zoomOutButton";
@@ -205,4 +212,5 @@
       this.zoomOutButton.UseVisualStyleBackColor = true;
       this.zoomOutButton.Click += new System.EventHandler(zoomOutButton_Click);
+      this.buttonToolTip.SetToolTip(this.zoomOutButton, "Zoom Out");
       // 
       // OperatorGraphView
@@ -241,4 +249,5 @@
     private System.Windows.Forms.Button connectButton;
     private System.Windows.Forms.Button panButton;
+    private System.Windows.Forms.ToolTip buttonToolTip;
   }
 }