Index: trunk/sources/HeuristicLab 3.3.sln
===================================================================
--- trunk/sources/HeuristicLab 3.3.sln	(revision 2910)
+++ trunk/sources/HeuristicLab 3.3.sln	(revision 2911)
@@ -49,5 +49,5 @@
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab 3.3", "HeuristicLab 3.3\HeuristicLab 3.3.csproj", "{B1DCDECA-B56E-41D5-9850-EF0D3A77DEAF}"
 	ProjectSection(ProjectDependencies) = postProject
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC} = {569E430B-B4CE-4B94-A44E-6246B6E4E3BC}
+		{489CFE09-FDF7-4C89-BAB5-BD09CADD61AD} = {489CFE09-FDF7-4C89-BAB5-BD09CADD61AD}
 		{72104A0B-90E7-42F3-9ABE-9BBBADD4B943} = {72104A0B-90E7-42F3-9ABE-9BBBADD4B943}
 		{25087811-F74C-4128-BC86-8324271DA13E} = {25087811-F74C-4128-BC86-8324271DA13E}
@@ -56,4 +56,5 @@
 		{14AB8D24-25BC-400C-A846-4627AA945192} = {14AB8D24-25BC-400C-A846-4627AA945192}
 		{C36BD924-A541-4A00-AFA8-41701378DDC5} = {C36BD924-A541-4A00-AFA8-41701378DDC5}
+		{6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6} = {6A5F8C2D-B0C3-4B36-BC20-9B1A91EE6DB6}
 		{1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB} = {1849A92E-DCFC-4E05-BB0A-D7B7A3DAFCFB}
 		{0E27A536-1C4A-4624-A65E-DC4F4F23E3E1} = {0E27A536-1C4A-4624-A65E-DC4F4F23E3E1}
@@ -71,4 +72,5 @@
 		{76945D76-CA61-4147-9DC2-0ACDCDDF87F9} = {76945D76-CA61-4147-9DC2-0ACDCDDF87F9}
 		{57F38579-409D-4DD8-AB19-3F2C4A665126} = {57F38579-409D-4DD8-AB19-3F2C4A665126}
+		{4ABA047D-46DD-4608-9E4A-41C5F92FDBB1} = {4ABA047D-46DD-4608-9E4A-41C5F92FDBB1}
 		{BF7D9494-A586-457B-8DF9-ED599F9E6A71} = {BF7D9494-A586-457B-8DF9-ED599F9E6A71}
 		{600287A3-8714-453E-B875-A05F3EB72315} = {600287A3-8714-453E-B875-A05F3EB72315}
@@ -125,6 +127,4 @@
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Operators.Views-3.3", "HeuristicLab.Operators.Views\3.3\HeuristicLab.Operators.Views-3.3.csproj", "{C49CB749-8B24-4628-8003-E86475749410}"
-EndProject
-Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.MainForm.Test-3.2", "HeuristicLab.MainForm.Test\3.2\HeuristicLab.MainForm.Test-3.2.csproj", "{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}"
 EndProject
 Project("{FAE04EC0-301F-11D3-BF4B-00C04F79EFBC}") = "HeuristicLab.Parameters-3.3", "HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj", "{56F9106A-079F-4C61-92F6-86A84C2D84B7}"
@@ -563,16 +563,4 @@
 		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.ActiveCfg = Release|x64
 		{C49CB749-8B24-4628-8003-E86475749410}.Release|x86.Build.0 = Release|x64
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|Any CPU.Build.0 = Debug|Any CPU
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|x64.ActiveCfg = Debug|x64
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|x64.Build.0 = Debug|x64
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|x86.ActiveCfg = Debug|x86
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Debug|x86.Build.0 = Debug|x86
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|Any CPU.ActiveCfg = Release|Any CPU
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|Any CPU.Build.0 = Release|Any CPU
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|x64.ActiveCfg = Release|x64
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|x64.Build.0 = Release|x64
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|x86.ActiveCfg = Release|x86
-		{569E430B-B4CE-4B94-A44E-6246B6E4E3BC}.Release|x86.Build.0 = Release|x86
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Debug|Any CPU.ActiveCfg = Debug|Any CPU
 		{56F9106A-079F-4C61-92F6-86A84C2D84B7}.Debug|Any CPU.Build.0 = Debug|Any CPU
Index: trunk/sources/HeuristicLab 3.3/Files.txt
===================================================================
--- trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2910)
+++ trunk/sources/HeuristicLab 3.3/Files.txt	(revision 2911)
@@ -23,5 +23,4 @@
 HeuristicLab.Logging\3.3:HeuristicLab.Logging-3.3.dll
 HeuristicLab.MainForm\3.2:HeuristicLab.MainForm-3.2.dll
-HeuristicLab.MainForm.Test\3.2:HeuristicLab.MainForm.Test-3.2.dll
 HeuristicLab.MainForm.WindowsForms\3.2:HeuristicLab.MainForm.WindowsForms-3.2.dll
 HeuristicLab.Operators\3.3:HeuristicLab.Operators-3.3.dll
Index: trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLab.CodeEditor-3.2.csproj
===================================================================
--- trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLab.CodeEditor-3.2.csproj	(revision 2910)
+++ trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLab.CodeEditor-3.2.csproj	(revision 2911)
@@ -122,4 +122,5 @@
       <DependentUpon>CodeViewer.cs</DependentUpon>
     </Compile>
+    <None Include="HeuristicLabCodeEditorPlugin.cs.frame" />
     <Compile Include="HeuristicLabCodeEditorPlugin.cs" />
     <Compile Include="ErrorBookmark.cs" />
@@ -159,5 +160,6 @@
 set Outdir=$(Outdir)
 
-call PreBuildEvent.cmd</PreBuildEvent>
+call PreBuildEvent.cmd
+SubWCRev "%25ProjectDir%25\" "%25ProjectDir%25\HeuristicLabCodeEditorPlugin.cs.frame" "%25ProjectDir%25\HeuristicLabCodeEditorPlugin.cs"</PreBuildEvent>
   </PropertyGroup>
 </Project>
Index: trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLab.CodeEditor-3.2.csproj.user
===================================================================
--- trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLab.CodeEditor-3.2.csproj.user	(revision 2910)
+++ 	(revision )
@@ -1,5 +1,0 @@
-﻿<Project xmlns="http://schemas.microsoft.com/developer/msbuild/2003">
-  <PropertyGroup>
-    <ProjectView>ProjectFiles</ProjectView>
-  </PropertyGroup>
-</Project>
Index: trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs	(revision 2910)
+++ 	(revision )
@@ -1,15 +1,0 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using System.Text;
-using HeuristicLab.PluginInfrastructure;
-
-namespace HeuristicLab.CodeEditor {
-
-  [Plugin("HeuristicLab.CodeEditor-3.2")]
-  [PluginFile("HeuristicLab.CodeEditor-3.2.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.Common.Resources","3.2.0.0")]
-  [PluginDependency("HeuristicLab.SharpDevelop-3.1.1.5327")]
-  public class HeuristicLabCodeEditorPlugin : PluginBase {
-  }
-}
Index: trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs.frame	(revision 2911)
+++ trunk/sources/HeuristicLab.CodeEditor/3.2/HeuristicLabCodeEditorPlugin.cs.frame	(revision 2911)
@@ -0,0 +1,35 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.PluginInfrastructure;
+
+namespace HeuristicLab.CodeEditor {
+  [Plugin("HeuristicLab.CodeEditor", "3.2.0.$WCREV$")]
+  [PluginFile("HeuristicLab.CodeEditor-3.2.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Common.Resources", "3.2")]
+  [PluginDependency("HeuristicLab.SharpDevelop", "3.1.1.5327")]
+  public class HeuristicLabCodeEditorPlugin : PluginBase {
+  }
+}
Index: trunk/sources/HeuristicLab.CodeEditor/3.2/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.CodeEditor/3.2/Properties/AssemblyInfo.frame	(revision 2910)
+++ trunk/sources/HeuristicLab.CodeEditor/3.2/Properties/AssemblyInfo.frame	(revision 2911)
@@ -1,6 +1,26 @@
-﻿using System.Reflection;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-using HeuristicLab.PluginInfrastructure;
 
 // General Information about an assembly is controlled through the following 
@@ -12,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2010 HEAL & Daniel Grunwald (#develop)")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL & Daniel Grunwald (#develop)")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -30,6 +50,4 @@
 //      Revision
 //
-[assembly: AssemblyVersion("3.2.0.$WCREV$")]
+[assembly: AssemblyVersion("3.2.0.0")]
 [assembly: AssemblyFileVersion("3.2.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]
-
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 2910)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/HeuristicLabSharpDevelopPlugin.cs	(revision 2911)
@@ -1,3 +1,24 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
@@ -6,6 +27,5 @@
 
 namespace HeuristicLab.SharpDevelop {
-
-  [Plugin("HeuristicLab.SharpDevelop-3.1.1.5327")]
+  [Plugin("HeuristicLab.SharpDevelop", "3.1.1.5327")]
   [PluginFile("ICSharpCode.TextEditor.dll", PluginFileType.Assembly)]
   [PluginFile("ICSharpCode.SharpDevelop.Dom.dll", PluginFileType.Assembly)]
@@ -14,5 +34,5 @@
   [PluginFile("Mono License.txt", PluginFileType.License)]
   [PluginFile("SharpDevelop License.txt", PluginFileType.License)]
-  [PluginDependency("HeuristicLab.log4net","1.2.10.0")]
+  [PluginDependency("HeuristicLab.log4net", "1.2.10.0")]
   public class HeuristicLabSharpDevelopPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Properties/AssemblyInfo.frame	(revision 2910)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.SharpDevelop/3.1.1.5327/Properties/AssemblyInfo.frame	(revision 2911)
@@ -1,6 +1,26 @@
-﻿using System.Reflection;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-using HeuristicLab.PluginInfrastructure;
 
 // General Information about an assembly is controlled through the following 
@@ -12,5 +32,5 @@
 [assembly: AssemblyCompany("")]
 [assembly: AssemblyProduct("HeuristicLab")]
-[assembly: AssemblyCopyright("(c) 2010 HEAL")]
+[assembly: AssemblyCopyright("(c) 2002-2010 HEAL")]
 [assembly: AssemblyTrademark("")]
 [assembly: AssemblyCulture("")]
@@ -36,4 +56,2 @@
 [assembly: AssemblyVersion("3.1.1.5327")]
 [assembly: AssemblyFileVersion("3.1.1.5327")]
-[assembly: AssemblyBuildDate("$WCNOW$")]
-
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/HeuristicLablog4netPlugin.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/HeuristicLablog4netPlugin.cs	(revision 2910)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/HeuristicLablog4netPlugin.cs	(revision 2911)
@@ -25,10 +25,10 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab.SQLite {
+namespace HeuristicLab.log4net {
   [Plugin("HeuristicLab.log4net", "1.2.10.0")]
   [PluginFile("HeuristicLab.log4net-1.2.10.0.dll", PluginFileType.Assembly)]
   [PluginFile("log4net.dll", PluginFileType.Assembly)]
   [PluginFile("log4net License.txt", PluginFileType.License)]
-  public class HeuristicLabSQLitePlugin : PluginBase {
+  public class HeuristicLablog4netPlugin : PluginBase {
   }
 }
Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/Properties/AssemblyInfo.frame	(revision 2910)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.log4net/1.2.10.0/Properties/AssemblyInfo.frame	(revision 2911)
@@ -1,3 +1,24 @@
-﻿using System.Reflection;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Reflection;
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame	(revision 2910)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/HeuristicLabOperatorsProgrammablePlugin.cs.frame	(revision 2911)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -28,8 +28,8 @@
   [Plugin("HeuristicLab.Operators.Programmable", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.Operators.Programmable-3.3.dll", PluginFileType.Assembly)]
-  [PluginDependency("HeuristicLab.CodeEditor-3.2")]
+  [PluginDependency("HeuristicLab.CodeEditor", "3.2")]
   [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
-  [PluginDependency("HeuristicLab.Core.Views", "3.3")]  
+  [PluginDependency("HeuristicLab.Core.Views", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 2910)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperator.cs	(revision 2911)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs	(revision 2910)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.Designer.cs	(revision 2911)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 2910)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/ProgrammableOperatorView.cs	(revision 2911)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
Index: trunk/sources/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame
===================================================================
--- trunk/sources/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame	(revision 2910)
+++ trunk/sources/HeuristicLab.Operators.Programmable/3.3/Properties/AssemblyInfo.frame	(revision 2911)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -23,5 +23,4 @@
 using System.Runtime.CompilerServices;
 using System.Runtime.InteropServices;
-using HeuristicLab.PluginInfrastructure;
 
 // General Information about an assembly is controlled through the following 
@@ -54,5 +53,4 @@
 // You can specify all the values or you can default the Revision and Build Numbers 
 // by using the '*' as shown below:
-[assembly: AssemblyVersion("3.3.0.$WCREV$")]
+[assembly: AssemblyVersion("3.3.0.0")]
 [assembly: AssemblyFileVersion("3.3.0.$WCREV$")]
-[assembly: AssemblyBuildDate("$WCNOW$")]