Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaBetaCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaBetaCrossover.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaBetaCrossover.cs	(revision 2921)
@@ -40,16 +40,29 @@
   [EmptyStorableClass]
   public class BlendAlphaBetaCrossover : RealVectorCrossover {
+    /// <summary>
+    /// Whether the problem is a maximization or minimization problem.
+    /// </summary>
     public ValueLookupParameter<BoolData> MaximizationParameter {
       get { return (ValueLookupParameter<BoolData>)Parameters["Maximization"]; }
     }
+    /// <summary>
+    /// The quality of the parents.
+    /// </summary>
     public SubScopesLookupParameter<DoubleData> QualityParameter {
       get { return (SubScopesLookupParameter<DoubleData>)Parameters["Quality"]; }
     }
+    /// <summary>
+    /// The alpha parameter specifies how much the interval between the parents should be extended in direction of the better parent.
+    /// </summary>
     public ValueLookupParameter<DoubleData> AlphaParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Alpha"]; }
     }
+    /// <summary>
+    /// The beta parameter specifies how much the interval between the parents should be extended in direction of the worse parent.
+    /// </summary>
     public ValueLookupParameter<DoubleData> BetaParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Beta"]; }
     }
+
     /// <summary>
     /// Initializes a new instance of <see cref="BlendAlphaBetaCrossover"/> with four additional parameters
Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaCrossover.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/BlendAlphaCrossover.cs	(revision 2921)
@@ -39,4 +39,10 @@
   [EmptyStorableClass]
   public class BlendAlphaCrossover : RealVectorCrossover {
+    /// <summary>
+    /// The alpha parameter specifies how much the interval between the parents should be extended to the left and right.
+    /// The value of this parameter also determines the name of the operator: BLX-0.0 for example means alpha is set to 0.
+    /// When Alpha is 0, then the offspring will only be chosen in between the parents, the bigger alpha is the more it will be possible to choose
+    /// values left and right of the min and max value for each gene.
+    /// </summary>
     public ValueLookupParameter<DoubleData> AlphaParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Alpha"]; }
Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/SimulatedBinaryCrossover.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/SimulatedBinaryCrossover.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Crossovers/SimulatedBinaryCrossover.cs	(revision 2921)
@@ -44,4 +44,8 @@
     }
 
+    /// <summary>
+    /// Initializes a new instance of <see cref="SimulatedBinaryCrossover"/> with one 
+    /// parameter (<c>Contiguity</c>).
+    /// </summary>
     public SimulatedBinaryCrossover()
       : base() {
Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformAllPositionsManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformAllPositionsManipulator.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformAllPositionsManipulator.cs	(revision 2921)
@@ -37,16 +37,31 @@
   [EmptyStorableClass]
   public class MichalewiczNonUniformAllPositionsManipulator : RealVectorManipulator {
+    /// <summary>
+    /// The lower bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MinimumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Minimum"]; }
     }
+    /// <summary>
+    /// The upper bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MaximumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Maximum"]; }
     }
+    /// <summary>
+    /// The current generation.
+    /// </summary>
     public LookupParameter<IntData> GenerationParameter {
       get { return (LookupParameter<IntData>)Parameters["Generation"]; }
     }
+    /// <summary>
+    /// The maximum generation.
+    /// </summary>
     public LookupParameter<IntData> MaximumGenerationsParameter {
       get { return (LookupParameter<IntData>)Parameters["MaximumGenerations"]; }
     }
+    /// <summary>
+    /// The parameter describing how much the mutation should depend on the progress towards the maximum generation.
+    /// </summary>
     public ValueLookupParameter<DoubleData> GenerationDependencyParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["GenerationDependency"]; }
Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformOnePositionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformOnePositionManipulator.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/MichalewiczNonUniformOnePositionManipulator.cs	(revision 2921)
@@ -37,16 +37,31 @@
   [EmptyStorableClass]
   public class MichalewiczNonUniformOnePositionManipulator : RealVectorManipulator {
+    /// <summary>
+    /// The lower bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MinimumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Minimum"]; }
     }
+    /// <summary>
+    /// The upper bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MaximumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Maximum"]; }
     }
+    /// <summary>
+    /// The current generation.
+    /// </summary>
     public LookupParameter<IntData> GenerationParameter {
       get { return (LookupParameter<IntData>)Parameters["Generation"]; }
     }
+    /// <summary>
+    /// The maximum generation.
+    /// </summary>
     public LookupParameter<IntData> MaximumGenerationsParameter {
       get { return (LookupParameter<IntData>)Parameters["MaximumGenerations"]; }
     }
+    /// <summary>
+    /// The parameter describing how much the mutation should depend on the progress towards the maximum generation.
+    /// </summary>
     public ValueLookupParameter<DoubleData> GenerationDependencyParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["GenerationDependency"]; }
Index: trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/UniformOnePositionManipulator.cs
===================================================================
--- trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/UniformOnePositionManipulator.cs	(revision 2920)
+++ trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Manipulators/UniformOnePositionManipulator.cs	(revision 2921)
@@ -36,8 +36,13 @@
   [EmptyStorableClass]
   public class UniformOnePositionManipulator : RealVectorManipulator {
+    /// <summary>
+    /// The lower bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MinimumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Minimum"]; }
     }
-
+    /// <summary>
+    /// The upper bound of the values in the real vector.
+    /// </summary>
     public ValueLookupParameter<DoubleData> MaximumParameter {
       get { return (ValueLookupParameter<DoubleData>)Parameters["Maximum"]; }