Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Auxiliary.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Auxiliary.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Auxiliary.cs	(revision 2929)
@@ -20,5 +20,5 @@
 #endregion
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   public static class Auxiliary {
     public static bool PermutationIsEqualByPosition(Permutation p1, Permutation p2) {
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CosaCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CosaCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CosaCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
     /// <summary>
     ///This is a test class for CosaCrossoverTest and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossover2Test.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossover2Test.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossover2Test.cs	(revision 2929)
@@ -2,5 +2,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
     /// <summary>
     ///This is a test class for CyclicCrossover2Test and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/CyclicCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for CyclicCrossover and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/EdgeRecombinationCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for EdgeRecombinationCrossover and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/HeuristicLab.Encodings.Permutation-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/HeuristicLab.Encodings.Permutation-3.3.Tests.csproj	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/HeuristicLab.Encodings.Permutation-3.3.Tests.csproj	(revision 2929)
@@ -8,5 +8,5 @@
     <OutputType>Library</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Encodings.Permutation.Tests</RootNamespace>
+    <RootNamespace>HeuristicLab.Encodings.Permutation_33.Tests</RootNamespace>
     <AssemblyName>HeuristicLab.Encodings.Permutation-3.3.Tests</AssemblyName>
     <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InsertionManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InsertionManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InsertionManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for InsertionManipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InversionManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InversionManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/InversionManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for InversionManipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/MaximalPreservativeCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for MaximalPreservativeCrossover and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderBasedCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
     /// <summary>
     ///This is a test class for OrderBasedCrossoverTest and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossover2Test.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossover2Test.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossover2Test.cs	(revision 2929)
@@ -2,5 +2,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
     /// <summary>
     ///This is a test class for OrderCrossover2Test and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/OrderCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
     /// <summary>
     ///This is a test class for OrderCrossoverTest and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PartiallyMatchedCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for PartiallyMatchedCrossover and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/PositionBasedCrossoverTest.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for PositionBasedCrossover and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Random.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Random.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Random.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   public class TestRandom : IRandom {
     #region Variables and Properties
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/ScrambleManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/ScrambleManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/ScrambleManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for ScrambleManipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap2ManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap2ManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap2ManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for Swap2Manipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap3ManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap3ManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/Swap3ManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for Swap3Manipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationInversionManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for TranslocationInversionManipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationManipulatorTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationManipulatorTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.Permutation/3.3/Tests/TranslocationManipulatorTest.cs	(revision 2929)
@@ -22,5 +22,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab.Encodings.Permutation.Tests {
+namespace HeuristicLab.Encodings.Permutation_33.Tests {
   /// <summary>
   ///This is a test class for TranslocationManipulator and is intended
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/Auxiliary.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/Auxiliary.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/Auxiliary.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using HeuristicLab.Common;
 
-namespace HeuristicLab.Encodings.RealVector.Tests {
+namespace HeuristicLab.Encodings.RealVector_33.Tests {
   public static class Auxiliary {
     public static bool RealVectorIsAlmostEqualByPosition(DoubleArrayData p1, DoubleArrayData p2) {
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/BlendAlphaCrossoverTest.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/BlendAlphaCrossoverTest.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/BlendAlphaCrossoverTest.cs	(revision 2929)
@@ -5,5 +5,5 @@
 using HeuristicLab.Parameters;
 
-namespace HeuristicLab.Encodings.RealVector.Tests {
+namespace HeuristicLab.Encodings.RealVector_33.Tests {
 
 
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/HeuristicLab.Encodings.RealVector-3.3.Tests.csproj
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/HeuristicLab.Encodings.RealVector-3.3.Tests.csproj	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/HeuristicLab.Encodings.RealVector-3.3.Tests.csproj	(revision 2929)
@@ -8,5 +8,5 @@
     <OutputType>Library</OutputType>
     <AppDesignerFolder>Properties</AppDesignerFolder>
-    <RootNamespace>HeuristicLab.Encodings.RealVector.Tests</RootNamespace>
+    <RootNamespace>HeuristicLab.Encodings.RealVector_33.Tests</RootNamespace>
     <AssemblyName>HeuristicLab.Encodings.RealVector-3.3.Tests</AssemblyName>
     <TargetFrameworkVersion>v3.5</TargetFrameworkVersion>
Index: /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/TestRandom.cs
===================================================================
--- /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/TestRandom.cs	(revision 2928)
+++ /trunk/sources/HeuristicLab.Encodings.RealVector/3.3/Tests/TestRandom.cs	(revision 2929)
@@ -23,5 +23,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab.Encodings.RealVector.Tests {
+namespace HeuristicLab.Encodings.RealVector_33.Tests {
   public class TestRandom : IRandom {
     #region Variables and Properties